/* Process model C form file: LLE1_process.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char LLE1_process_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3ECB01F7 3ECB01F7 1 luna vladimir 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                          ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "gprs_llc.h"

/* incoming stream macros */
#define LLME_TO_LLE1		0
#define MUX_TO_LLE1			1
#define UPPERLAYER_TO_LLE1	2

/* outgoing stream macros */
#define LLE1_TO_MUX			0 
#define LLE1_TO_UPPERLAYER	1


/* transition macros */
#define PACKET_FROM_LLME (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == LLME_TO_LLE1)
#define PACKET_FROM_MUX (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == MUX_TO_LLE1)
#define PACKET_FROM_GMM (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == UPPERLAYER_TO_LLE1)



/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	imsi_record	            		LLE1_imsi_records[100];
	Stathandle	             		LLE_packet_count;
	} LLE1_process_state;

#define pr_state_ptr            		((LLE1_process_state*) SimI_Mod_State_Ptr)
#define LLE1_imsi_records       		pr_state_ptr->LLE1_imsi_records
#define LLE_packet_count        		pr_state_ptr->LLE_packet_count

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	LLE1_process_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
static Packet* generate (char packet_type[30])
	{
	Packet*				pkptr;
	double				pksize;
   
	FIN (generate ());

	
	/* Create a formatted packet */
	pkptr = op_pk_create_fmt (packet_type);
	
	
	FRET (pkptr);

	}	


/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void LLE1_process (void);
	Compcode LLE1_process_init (void **);
	void LLE1_process_diag (void);
	void LLE1_process_terminate (void);
	void LLE1_process_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
LLE1_process (void)
	{
	int _block_origin = 0;
	FIN (LLE1_process ());
	if (1)
		{


		FSM_ENTER (LLE1_process)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "LLE1_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [init enter execs]", state0_enter_exec)
				{
				// initialize the state variables for each MS (imsi).
				int i;
				
				for (i=0; i < MAX_SUPPORTED_MS; i++)
					{
					    LLE1_imsi_records[i].imsi = i; //imsi and tlli are the same in this impl.
						LLE1_imsi_records[i].tlli_new = 0; 
						LLE1_imsi_records[i].tlli_old = 0;
						LLE1_imsi_records[i].state = TLLI_UNASSIGNED;
					} 
				
				}

				FSM_PROFILE_SECTION_OUT ("LLE1_process [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "LLE1_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE1_process [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "LLE1_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [idle enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("LLE1_process [idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,LLE1_process)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "LLE1_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [idle exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE1_process [idle exit execs]", state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("LLE1_process [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PACKET_FROM_LLME)
			FSM_TEST_COND (PACKET_FROM_GMM)
			FSM_TEST_COND (PACKET_FROM_MUX)
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("LLE1_process [idle trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PACKET_FROM_LLME", "", "idle", "rec_llme")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PACKET_FROM_GMM", "", "idle", "rec_gmm")
				FSM_CASE_TRANSIT (2, 4, state4_enter_exec, ;, "PACKET_FROM_MUX", "", "idle", "rec_mux")
				}
				/*---------------------------------------------------------*/



			/** state (rec_llme) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "rec_llme", "LLE1_process [rec_llme enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [rec_llme enter execs]", state2_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				int imsi, tlli_new, tlli_old; 
				int result;	
				int message_type;
					
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (LLME_TO_LLE1);
				
				// Check message type and act accordingly
				result=op_pk_nfd_get(in_packet_ptr,"message_type", &message_type);
					
				switch (message_type) {
				    
					case gprs_LLME_LLE_ASSIGN:
					
					// TLLI assignment for a certain cell-phone (imsi). 
					//Set ADM state for imsi (equal to state TLLI_ASSIGNED)
					
					//Extract values from packet
					result=op_pk_nfd_get(in_packet_ptr,"tlli_old", &tlli_old);
					result=op_pk_nfd_get(in_packet_ptr,"tlli_new", &tlli_new);
					result=op_pk_nfd_get(in_packet_ptr,"imsi", &imsi);
					
					//Set new state for imsi in LLE1
					LLE1_imsi_records[imsi].state = TLLI_ASSIGNED;
					
					//Set assigned tlli-values, which in this implementation are equal to imsi
					LLE1_imsi_records[imsi].tlli_new = tlli_new; 
					LLE1_imsi_records[imsi].tlli_old = tlli_old;
					
				    	break;
					
				    default:
					    break;
					   }
				
				/*destroy the packet*/	
				op_pk_destroy (in_packet_ptr);
				
				
				
				
				
				}

				FSM_PROFILE_SECTION_OUT ("LLE1_process [rec_llme enter execs]", state2_enter_exec)

			/** state (rec_llme) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "rec_llme", "LLE1_process [rec_llme exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [rec_llme exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE1_process [rec_llme exit execs]", state2_exit_exec)


			/** state (rec_llme) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "rec_llme", "idle")
				/*---------------------------------------------------------*/



			/** state (rec_gmm) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "rec_gmm", "LLE1_process [rec_gmm enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [rec_gmm enter execs]", state3_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				int message_type; 
				int result, imsi;	
				Packet* l3_pdu_ptr;
				
					
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (UPPERLAYER_TO_LLE1);
				
				result=op_pk_nfd_get(in_packet_ptr, "imsi", &imsi);
				
				
				if (LLE1_imsi_records[imsi].state == TLLI_UNASSIGNED)
					{
						printf("LLE1: RECEIVED PACKET FROM GMM IN TLLI_UNASSIGNED STATE\n");
					}
				else
					{
						
						result=op_pk_nfd_get(in_packet_ptr, "message_type", &message_type);
					 
						switch (message_type) {
				    
							case gprs_LL_UNITDATA_REQ:
								
							
								//Just send packet on down to MUX.
								out_packet_ptr = in_packet_ptr;
								if (out_packet_ptr==OPC_NIL) 
									{
										printf("LL1: PACKET POINTER=NIL!!\n");
									}
								else
									{
										op_pk_send(out_packet_ptr, LLE1_TO_MUX);				
									}	
					
							break;
					
							default:
								
							break;
						 }
					}
				
				
				
				
				
				
				}

				FSM_PROFILE_SECTION_OUT ("LLE1_process [rec_gmm enter execs]", state3_enter_exec)

			/** state (rec_gmm) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "rec_gmm", "LLE1_process [rec_gmm exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [rec_gmm exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE1_process [rec_gmm exit execs]", state3_exit_exec)


			/** state (rec_gmm) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "rec_gmm", "idle")
				/*---------------------------------------------------------*/



			/** state (rec_mux) enter executives **/
			FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "rec_mux", "LLE1_process [rec_mux enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [rec_mux enter execs]", state4_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				Packet* l3_pdu_ptr;
				int message_type; 
				int my_header;
				int result, imsi;	
					
				/* Get a pointer to received packet*/
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (MUX_TO_LLE1);
				
				result=op_pk_nfd_get(in_packet_ptr, "tlli", &imsi);
				
				if (LLE1_imsi_records[imsi].state == TLLI_UNASSIGNED)
					{
						printf("LLE1: RECEIVED PACKET FROM MUX IN TLLI_UNASSIGNED STATE\n");
					}
				else
					{
						
							result=op_pk_nfd_get(in_packet_ptr, "information", &l3_pdu_ptr);
							
							//Create gprs_LL_UNITDATA_IND, extract payload from gprs_LLC_FRAME, put it
							//in ..DATA_IND and send up to GMM 
							out_packet_ptr=generate("gprs_LL_UNITDATA_IND");
							if (out_packet_ptr==OPC_NIL) 
								{
									printf("LLE1: pkptr=NIL\n");
								}
							else
								{
									op_pk_nfd_set(out_packet_ptr, "message_type", gprs_LL_UNITDATA_IND);
									op_pk_nfd_set(out_packet_ptr, "tlli", imsi);
									op_pk_nfd_set(out_packet_ptr, "imsi", imsi);
									op_pk_nfd_set(out_packet_ptr, "l3_pdu", l3_pdu_ptr); 
									op_pk_send(out_packet_ptr, LLE1_TO_UPPERLAYER);
								} 
						
					}
				
				
				
				}

				FSM_PROFILE_SECTION_OUT ("LLE1_process [rec_mux enter execs]", state4_enter_exec)

			/** state (rec_mux) exit executives **/
			FSM_STATE_EXIT_FORCED (4, "rec_mux", "LLE1_process [rec_mux exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE1_process [rec_mux exit execs]", state4_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE1_process [rec_mux exit execs]", state4_exit_exec)


			/** state (rec_mux) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "rec_mux", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,LLE1_process)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
LLE1_process_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (LLE1_process_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (LLE1_process)",
			sizeof (LLE1_process_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((LLE1_process_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
LLE1_process_diag (void)
	{
	/* No Diagnostic Block */
	}




void
LLE1_process_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (LLE1_process_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in LLE1_process_svar function. */
#undef LLE1_imsi_records
#undef LLE_packet_count



void
LLE1_process_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	LLE1_process_state		*prs_ptr;

	FIN (LLE1_process_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (LLE1_process_state *)gen_ptr;

	if (strcmp ("LLE1_imsi_records" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->LLE1_imsi_records);
		FOUT
		}
	if (strcmp ("LLE_packet_count" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->LLE_packet_count);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

