/* Process model C form file: Mux_process.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char Mux_process_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3ECAD2F5 3ECAD2F5 1 luna vladimir 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                          ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "gprs_llc.h"

/* incoming stream macros */
#define LLE1_TO_MUX			0
#define LLE3_TO_MUX			1
#define LOWERLAYER_TO_MUX	2

/* outgoing stream macros */
#define MUX_TO_LLE1			0 
#define MUX_TO_LLE3			1 
#define MUX_TO_LOWERLAYER	2 


/* transition macros */

#define LLEx_TO_MUX  (op_intrpt_strm () == LLE1_TO_MUX ) || (op_intrpt_strm () == LLE3_TO_MUX)
#define PACKET_FROM_LLEx (op_intrpt_type () == OPC_INTRPT_STRM && LLEx_TO_MUX)

#define PACKET_FROM_LLE1 (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == LLE1_TO_MUX )
#define PACKET_FROM_LLE3 (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == LLE3_TO_MUX )

#define PACKET_FROM_LOWERLAYER (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == LOWERLAYER_TO_MUX)


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Stathandle	             		LLC_mux;
	} Mux_process_state;

#define pr_state_ptr            		((Mux_process_state*) SimI_Mod_State_Ptr)
#define LLC_mux                 		pr_state_ptr->LLC_mux

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	Mux_process_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
static Packet* generate (char packet_type[30])
	{
	Packet*				pkptr;
	double				pksize;
   
	FIN (generate ());

	
	/* Create a formatted packet */
	pkptr = op_pk_create_fmt (packet_type);
	
	
	FRET (pkptr);

	}	


/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void Mux_process (void);
	Compcode Mux_process_init (void **);
	void Mux_process_diag (void);
	void Mux_process_terminate (void);
	void Mux_process_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
Mux_process (void)
	{
	int _block_origin = 0;
	FIN (Mux_process ());
	if (1)
		{


		FSM_ENTER (Mux_process)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "Mux_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [init enter execs]", state0_enter_exec)
				{
				
				//Register Global statistic variables
				LLC_mux = op_stat_reg ("LLC mux of packets (Service Access Point)", OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				printf("MUX: LLC_mux stat registered");
				}

				FSM_PROFILE_SECTION_OUT ("Mux_process [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "Mux_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("Mux_process [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "Mux_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [idle enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("Mux_process [idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,Mux_process)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "Mux_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [idle exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("Mux_process [idle exit execs]", state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("Mux_process [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PACKET_FROM_LOWERLAYER)
			FSM_TEST_COND (PACKET_FROM_LLEx)
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("Mux_process [idle trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PACKET_FROM_LOWERLAYER", "", "idle", "demux")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PACKET_FROM_LLEx", "", "idle", "mux ")
				}
				/*---------------------------------------------------------*/



			/** state (demux) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "demux", "Mux_process [demux enter execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [demux enter execs]", state2_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				Packet* ll_pdu_ptr;
				int my_tlli; 
				int result;	
				int address;
					
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (LOWERLAYER_TO_MUX);
				
				//Extract ll_pdu (LLC-FRAME) from gprs_GRR_UNITDATA_IND
				result=op_pk_nfd_get(in_packet_ptr, "ll_pdu",&ll_pdu_ptr);
				
				
				//Check address-field to see which SAPI packet should be sent to
				//This implementation supports LLE1 and LLE3
				result=op_pk_nfd_get(ll_pdu_ptr, "address", &address);
				
				out_packet_ptr = ll_pdu_ptr;
				
				
				
				if (address==1)
					{
						op_pk_send(out_packet_ptr, MUX_TO_LLE1);	
					}
				
				if (address==3)
					{
					op_pk_send(out_packet_ptr, MUX_TO_LLE3);
							 
					}
				
				}

				FSM_PROFILE_SECTION_OUT ("Mux_process [demux enter execs]", state2_enter_exec)

			/** state (demux) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "demux", "Mux_process [demux exit execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [demux exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("Mux_process [demux exit execs]", state2_exit_exec)


			/** state (demux) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "demux", "idle")
				/*---------------------------------------------------------*/



			/** state (mux ) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "mux ", "Mux_process [mux  enter execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [mux  enter execs]", state3_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				Packet* llc_packet_ptr;
				Packet* l3_pdu_ptr;
				int result;
				int message_type;
				int my_tlli;
				int my_address;
				int my_prec_class;
				int prio;
				double pk_size, llc_header_size, l3_pdu_size, llc_packet_size;
				double gprs_GRR_UNITDATA_REQ_header_size;
				
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (op_intrpt_strm());
				
				if (PACKET_FROM_LLE1)
					{
						my_address=1;
						op_stat_write(LLC_mux, my_address);
					}
					else if (PACKET_FROM_LLE3) 
						{
							my_address=3;
							op_stat_write(LLC_mux, my_address);
						}
						else
							{
								printf("MUX: PACKET NOT FROM LLEx \n");
							}
					
				result = op_pk_nfd_get(in_packet_ptr, "tlli", &my_tlli);
				// create new empty LLC-frame 
				llc_packet_ptr=generate("gprs_LLC_FRAME");
				if (llc_packet_ptr==OPC_NIL) 
					{
						printf("MUX: pkptr=NIL\n");
					}
				else
					{
				
					//The address field is 8 bits: PD(1), C/R(1), X(1), X(1), SAPI(4)
				
					//PD - Protocol Discriminator:
					//Indicates where a frame is an LLC frame or not. LLC frames have PD set to 0.
							
					//C/R - Command/Response:
					//Identifies an LLC frame as either a command or a response. MS sends commands
					//with C/R=0, and responsens with C/R=1. SGSN does the opposite. As of now this
					//implementation does not use this field.
					
					//SAPI -Service Access Point Identifier
					//Identifies LLE, which in this implementation is either 0001(LLE1) or 0011(LLE3)
							
					//As of now, only the SAPI part of the address field is used by this implementation.
					result = op_pk_nfd_set (llc_packet_ptr, "tlli", my_tlli );
					result = op_pk_nfd_set (llc_packet_ptr, "address", my_address );
					
					//Extract message_type from packet (gprs_LL_UNITDATA_REQ) 
					//result = op_pk_nfd_get(in_packet_ptr, "message_type", &message_type);
				   
					result = op_pk_nfd_get(in_packet_ptr, "l3_pdu", &l3_pdu_ptr);
					
					llc_header_size= (double) op_pk_total_size_get(llc_packet_ptr);
					l3_pdu_size= (double) op_pk_total_size_get(l3_pdu_ptr);
					llc_packet_size=llc_header_size+l3_pdu_size;
					
					//Set the size we want the packet to show the network
					op_pk_total_size_set (llc_packet_ptr,llc_packet_size);
					
					result=op_pk_nfd_set(llc_packet_ptr, "information", l3_pdu_ptr);	
								
					//Extract other parameters from LL_UNITDATA_REQ and set in gprs_GRR_UNITDATA_REQ or use  
					//in order to make priority decisions.
				
					//Create gprs_GRR_UNITDATA_REQ, set parameters and encapsulate llc_frame before sending down to
					//lower layer (RLC/MAC or BSSGP)
					out_packet_ptr = op_pk_create_fmt ("gprs_GRR_UNITDATA_REQ");
					op_pk_nfd_set (out_packet_ptr, "message_type", gprs_GRR_UNITDATA_REQ);
					op_pk_nfd_set (out_packet_ptr, "ll_pdu", llc_packet_ptr);
					
					gprs_GRR_UNITDATA_REQ_header_size= (double) op_pk_total_size_get(out_packet_ptr);
					//Set the size we want the packet to show the network
					op_pk_total_size_set (out_packet_ptr,llc_packet_size+gprs_GRR_UNITDATA_REQ_header_size);
					
					//Extract precedence_class from packet (gprs_LL_UNITDATA_REQ) 
					result = op_pk_nfd_get(in_packet_ptr, "precedence_class", &my_prec_class);
					if (my_prec_class==1)
						{
							prio=PRIO_HIGH;
						}
						else if (my_prec_class==2)
							{
								prio=PRIO_NORMAL;
							}
							else if (my_prec_class==3)
								{
									prio=PRIO_LOW;
								}
							else
								{
									printf("MUX: Unknown precedence class\n");
								}
							
					//Set packet prio
					op_pk_priority_set(out_packet_ptr, prio);
				  
					op_pk_send(out_packet_ptr, MUX_TO_LOWERLAYER);
				
				  }
				
				
				
				
				}

				FSM_PROFILE_SECTION_OUT ("Mux_process [mux  enter execs]", state3_enter_exec)

			/** state (mux ) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "mux ", "Mux_process [mux  exit execs]")
				FSM_PROFILE_SECTION_IN ("Mux_process [mux  exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("Mux_process [mux  exit execs]", state3_exit_exec)


			/** state (mux ) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "mux ", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,Mux_process)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
Mux_process_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (Mux_process_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (Mux_process)",
			sizeof (Mux_process_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((Mux_process_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
Mux_process_diag (void)
	{
	/* No Diagnostic Block */
	}




void
Mux_process_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (Mux_process_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in Mux_process_svar function. */
#undef LLC_mux



void
Mux_process_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	Mux_process_state		*prs_ptr;

	FIN (Mux_process_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (Mux_process_state *)gen_ptr;

	if (strcmp ("LLC_mux" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->LLC_mux);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

