/* Process model C form file: activationProcedure.pr.c */
/* Portions of this file copyright 1992-2000 by OPNET, Inc. */



/* This variable carries the header into the object file */
static const char activationProcedure_pr_c [] = "MIL_3_Tfile_Hdr_ 70B 30A opnet 7 3BE5B9BC 3BE5B9BC 1 pauli rickyn 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                           ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */


#define ACTIVATION_RCV_IN_STRM 0

#define ACTIVATION_SRC_IN_STRM 1

#define ACTIVATION_XMT_OUT_STRM 0

#define ACTIVATION_ACCEPT 0x06


/* transition macros */
#define ACTIVATION_SRC_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == ACTIVATION_SRC_IN_STRM)

#define ACTIVATION_RCV_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == ACTIVATION_RCV_IN_STRM)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Distribution *	         		imsi_distribution;
	Stathandle	             		activationProcessTime_gsh;
	char	                   		debugStr[1000];
	} activationProcedure_state;

#define pr_state_ptr            		((activationProcedure_state*) SimI_Mod_State_Ptr)
#define imsi_distribution       		pr_state_ptr->imsi_distribution
#define activationProcessTime_gsh		pr_state_ptr->activationProcessTime_gsh
#define debugStr                		pr_state_ptr->debugStr

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	activationProcedure_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void activationProcedure (void);
	Compcode activationProcedure_init (void **);
	void activationProcedure_diag (void);
	void activationProcedure_terminate (void);
	void activationProcedure_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
activationProcedure (void)
	{
	int _block_origin = 0;
	FIN (activationProcedure ());
	if (1)
		{
		Packet *pkptr;
		
		double activationProcessTime;
		
		double sentTime;


		FSM_ENTER (activationProcedure)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "activationProcedure () [init enter execs]")
				{
				// currently supports only 1000 subscribers
				imsi_distribution = op_dist_load ("uniform_int", 0, 999);
				
				activationProcessTime_gsh = op_stat_reg ("Activation Process Time",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "activationProcedure () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "activationProcedure () [idle enter execs]")
				{
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,activationProcedure)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle", "activationProcedure () [idle exit execs]")
				{
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (ACTIVATION_SRC_ARRIVAL)
			FSM_TEST_COND (ACTIVATION_RCV_ARRIVAL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;)
				FSM_CASE_TRANSIT (2, 1, state1_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (activationXmt) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "activationXmt", "activationProcedure () [activationXmt enter execs]")
				{
				pkptr = op_pk_get (ACTIVATION_SRC_IN_STRM);
				sentTime = op_sim_time ();
				// set the activation request sent time
				op_pk_nfd_set (pkptr, "activationReqSentTime",
					sentTime);
				sprintf (debugStr, "Activation Req sent.  Activation Req sent time %f", sentTime);
				op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				
				// set the imsi of the MS
				op_pk_nfd_set (pkptr, "ptmsi",
					(int)op_dist_outcome(imsi_distribution));
				op_pk_send(pkptr, ACTIVATION_XMT_OUT_STRM);
				}


			/** state (activationXmt) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "activationXmt", "activationProcedure () [activationXmt exit execs]")
				{
				}


			/** state (activationXmt) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (activationRcv) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "activationRcv", "activationProcedure () [activationRcv enter execs]")
				{
				double activationReqSentTime;
				
				pkptr = op_pk_get(ACTIVATION_RCV_IN_STRM);
				op_pk_nfd_get (pkptr, "activationReqSentTime", &activationReqSentTime);
				activationProcessTime = op_sim_time() - activationReqSentTime;
				op_stat_write(activationProcessTime_gsh, activationProcessTime);
				
				sprintf (debugStr, "Activation Accept Recv. Activation Req sent time %f", activationReqSentTime);
				//op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				sprintf (debugStr, "Activation Accept Recv. Activation Accept Recv time %f", op_sim_time());
				//op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				
				op_pk_destroy(pkptr);
				}


			/** state (activationRcv) exit executives **/
			FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "activationRcv", "activationProcedure () [activationRcv exit execs]")
				{
				}


			/** state (activationRcv) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,activationProcedure)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
activationProcedure_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (activationProcedure_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (activationProcedure)",
			sizeof (activationProcedure_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((activationProcedure_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
activationProcedure_diag (void)
	{
	/* No Diagnostic Block */
	}




void
activationProcedure_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (activationProcedure_terminate (void))

	if (1)
		{
		Packet *pkptr;
		
		double activationProcessTime;
		
		double sentTime;

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in activationProcedure_svar function. */
#undef imsi_distribution
#undef activationProcessTime_gsh
#undef debugStr



void
activationProcedure_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	activationProcedure_state		*prs_ptr;

	FIN (activationProcedure_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (activationProcedure_state *)gen_ptr;

	if (strcmp ("imsi_distribution" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->imsi_distribution);
		FOUT;
		}
	if (strcmp ("activationProcessTime_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->activationProcessTime_gsh);
		FOUT;
		}
	if (strcmp ("debugStr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->debugStr);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}

