/* Process model C form file: gprs_lower_layer_process.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char gprs_lower_layer_process_pr_c [] = "MIL_3_Tfile_Hdr_ 90A 30A opnet 7 3E970E28 3E970E28 1 payette mjohanss 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                       ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

//Current layer is named LOWERLAYER and represents RLC/MAC 
//on the MS side and BSSGP on the SGSN side. It also 
//represents the physical layers in the GPRS stack

#include "gprs_llc.h"

/* incoming stream macros */
#define LLC_TO_LOWERLAYER			0
#define RX_TO_LOWERLAYER			1

/* outgoing stream macros */
#define LOWERLAYER_TO_LLC			0 
#define LOWERLAYER_TO_TX			1

/* transition macros */
#define PACKET_FROM_RX (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == RX_TO_LOWERLAYER)
#define PACKET_FROM_LLC (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == LLC_TO_LOWERLAYER)


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	} gprs_lower_layer_process_state;

#define pr_state_ptr            		((gprs_lower_layer_process_state*) SimI_Mod_State_Ptr)

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	gprs_lower_layer_process_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void gprs_lower_layer_process (void);
	Compcode gprs_lower_layer_process_init (void **);
	void gprs_lower_layer_process_diag (void);
	void gprs_lower_layer_process_terminate (void);
	void gprs_lower_layer_process_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
gprs_lower_layer_process (void)
	{
	int _block_origin = 0;
	FIN (gprs_lower_layer_process ());
	if (1)
		{


		FSM_ENTER (gprs_lower_layer_process)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "gprs_lower_layer_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [init enter execs]", state0_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "gprs_lower_layer_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "gprs_lower_layer_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [idle enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,gprs_lower_layer_process)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "gprs_lower_layer_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [idle exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [idle exit execs]", state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PACKET_FROM_LLC)
			FSM_TEST_COND (PACKET_FROM_RX)
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [idle trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PACKET_FROM_LLC", "", "idle", "send")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PACKET_FROM_RX", "", "idle", "rec")
				}
				/*---------------------------------------------------------*/



			/** state (send) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "send", "gprs_lower_layer_process [send enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [send enter execs]", state2_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				Packet* ll_pdu_ptr;
				int my_value; 
				int result;	
					
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (LLC_TO_LOWERLAYER);
				
				
				//Extract LLC-frame from gprs_GRR_UNITDTA_REQ 
				result = op_pk_nfd_get(in_packet_ptr, "ll_pdu", &ll_pdu_ptr);
				
				//Send packet (gprs_LLC_FRAME)to Lower Layer peer in SGSN
				out_packet_ptr = ll_pdu_ptr;
				
				op_pk_send(out_packet_ptr, LOWERLAYER_TO_TX);
				
				/*destroy the incoming packet*/	
				op_pk_destroy (in_packet_ptr);
				
				}

				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [send enter execs]", state2_enter_exec)

			/** state (send) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "send", "gprs_lower_layer_process [send exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [send exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [send exit execs]", state2_exit_exec)


			/** state (send) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "send", "idle")
				/*---------------------------------------------------------*/



			/** state (rec) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "rec", "gprs_lower_layer_process [rec enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [rec enter execs]", state3_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				int my_value; 
				int result, tlli;	
				double llc_frame_size, gprs_GRR_UNITDATA_IND_header_size;
				double gprs_GRR_UNITDATA_IND_size;
					
				/* Get a pointer to received packet, which is and gprs_LLC_FRAME*/
				in_packet_ptr = op_pk_get (RX_TO_LOWERLAYER);
				
				llc_frame_size= (double) op_pk_total_size_get(in_packet_ptr);
				
				result=op_pk_nfd_get(in_packet_ptr, "tlli", &tlli);
				
				//Create gprs_GRR_UNITDATA_IND, put LLC-frame inside and send up
				//to LLC for demultiplexing 
				
				out_packet_ptr = op_pk_create_fmt ("gprs_GRR_UNITDATA_IND");
				result=op_pk_nfd_set(out_packet_ptr, "ll_pdu", in_packet_ptr);
				result=op_pk_nfd_set(out_packet_ptr, "tlli", tlli);
				result=op_pk_nfd_set(out_packet_ptr, "message_type", gprs_GRR_UNITDATA_IND);
				
				gprs_GRR_UNITDATA_IND_header_size= (double) op_pk_total_size_get (out_packet_ptr);
				gprs_GRR_UNITDATA_IND_size=gprs_GRR_UNITDATA_IND_header_size+llc_frame_size;
				
				//Set size we want packet to show network
				op_pk_total_size_set(out_packet_ptr, gprs_GRR_UNITDATA_IND_size);
				
				op_pk_send(out_packet_ptr, LOWERLAYER_TO_LLC);
				
				}

				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [rec enter execs]", state3_enter_exec)

			/** state (rec) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "rec", "gprs_lower_layer_process [rec exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [rec exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("gprs_lower_layer_process [rec exit execs]", state3_exit_exec)


			/** state (rec) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "rec", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,gprs_lower_layer_process)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
gprs_lower_layer_process_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (gprs_lower_layer_process_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (gprs_lower_layer_process)",
			sizeof (gprs_lower_layer_process_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((gprs_lower_layer_process_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
gprs_lower_layer_process_diag (void)
	{
	/* No Diagnostic Block */
	}




void
gprs_lower_layer_process_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (gprs_lower_layer_process_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}




void
gprs_lower_layer_process_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{

	FIN (gprs_lower_layer_process_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

