/* Process model C form file: hlr_map_performing_ssm_process_model.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char hlr_map_performing_ssm_process_model_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3ECB01C5 3ECB01C5 1 luna vladimir 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                          ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "map.h"

// Definitions of packet streams

#define MAP_DSM_IN_STRM 0
#define MAP_USER_OUT_STRM 0
#define MAP_SGSN_OUT_STRM 1
#define MAP_GGSN_OUT_STRM 2

#define CNF_REQUIRED cnfRequired
#define PSM_TIMEOUT 30
#define PSM_TIMER_EXPIRED 7

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	} hlr_map_performing_ssm_process_model_state;

#define pr_state_ptr            		((hlr_map_performing_ssm_process_model_state*) SimI_Mod_State_Ptr)

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	hlr_map_performing_ssm_process_model_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void hlr_map_performing_ssm_process_model (void);
	Compcode hlr_map_performing_ssm_process_model_init (void **);
	void hlr_map_performing_ssm_process_model_diag (void);
	void hlr_map_performing_ssm_process_model_terminate (void);
	void hlr_map_performing_ssm_process_model_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
hlr_map_performing_ssm_process_model (void)
	{
	int _block_origin = 0;
	FIN (hlr_map_performing_ssm_process_model ());
	if (1)
		{
		Packet* pkptr;
		int	intrpt_type;
		int cnfRequired = 0;
		int messageType;
		int operation;
		


		FSM_ENTER (hlr_map_performing_ssm_process_model)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (IDLE) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, state0_enter_exec, "IDLE", "hlr_map_performing_ssm_process_model [IDLE enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_performing_ssm_process_model [IDLE enter execs]", state0_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("hlr_map_performing_ssm_process_model [IDLE enter execs]", state0_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,hlr_map_performing_ssm_process_model)


			/** state (IDLE) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "IDLE", "hlr_map_performing_ssm_process_model [IDLE exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_performing_ssm_process_model [IDLE exit execs]", state0_exit_exec)
				{
				Packet* map_pdu_pkptr;
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
				pkptr = op_pk_get(op_intrpt_strm());
				op_pk_nfd_get(pkptr, "messageType", &messageType);
				switch (messageType) {
					case TC_INVOKE_IND:
						op_pk_nfd_get(pkptr, "operation", &operation);
						op_pk_nfd_get(pkptr, "mapPDU", &map_pdu_pkptr);
						switch (operation) {
							case MAP_CANCEL_LOCATION_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_CANCEL_LOCATION_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_PURGE_MS_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_PURGE_MS_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_RESET_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_RESET_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								break;
							case MAP_SEND_AUTHENTICATION_INFO_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_SEND_AUTHENTICATION_INFO_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_UPDATE_GPRS_LOCATION_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_UPDATE_GPRS_LOCATION_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_INSERT_SUBSCRIBER_DATA_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_INSERT_SUBSCRIBER_DATA_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_DELETE_SUBSCRIBER_DATA_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_DELETE_SUBSCRIBER_DATA_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_NOTE_MS_PRESENT_FOR_GPRS_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_NOTE_MS_PRESENT_FOR_GPRS_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_SEND_ROUTING_INFO_FOR_GPRS_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_SEND_ROUTING_INFO_FOR_GPRS_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							case MAP_FAILURE_REPORT_REQ:
								op_pk_nfd_set(map_pdu_pkptr, "messageType", MAP_FAILURE_REPORT_IND);
								op_pk_send(map_pdu_pkptr, MAP_USER_OUT_STRM);
								cnfRequired = 1;
								break;
							default:
								break;
						}
						break;
					default:
						break;
				}
				}
				}
				FSM_PROFILE_SECTION_OUT ("hlr_map_performing_ssm_process_model [IDLE exit execs]", state0_exit_exec)


			/** state (IDLE) transition processing **/
			FSM_PROFILE_SECTION_IN ("hlr_map_performing_ssm_process_model [IDLE trans conditions]", state0_trans_conds)
			FSM_INIT_COND (CNF_REQUIRED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("IDLE")
			FSM_PROFILE_SECTION_OUT ("hlr_map_performing_ssm_process_model [IDLE trans conditions]", state0_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "CNF_REQUIRED", "", "IDLE", "WAIT_FOR_RESPONSE")
				FSM_CASE_TRANSIT (1, 0, state0_enter_exec, ;, "default", "", "IDLE", "IDLE")
				}
				/*---------------------------------------------------------*/



			/** state (WAIT_FOR_RESPONSE) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "WAIT_FOR_RESPONSE", "hlr_map_performing_ssm_process_model [WAIT_FOR_RESPONSE enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_performing_ssm_process_model [WAIT_FOR_RESPONSE enter execs]", state1_enter_exec)
				{
				//op_intrpt_schedule_self(op_sim_time() + PSM_TIMEOUT, PSM_TIMER_EXPIRED);
				}

				FSM_PROFILE_SECTION_OUT ("hlr_map_performing_ssm_process_model [WAIT_FOR_RESPONSE enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,hlr_map_performing_ssm_process_model)


			/** state (WAIT_FOR_RESPONSE) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "WAIT_FOR_RESPONSE", "hlr_map_performing_ssm_process_model [WAIT_FOR_RESPONSE exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_performing_ssm_process_model [WAIT_FOR_RESPONSE exit execs]", state1_exit_exec)
				{
				Packet* tc_result_l_req_pkptr;
				Packet* tc_continue_req_pkptr;
				Packet* tc_u_reject_req_pkptr;
				int userError;
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
				pkptr = op_pk_get(op_intrpt_strm());
				op_pk_nfd_get(pkptr, "messageType", &messageType);
				switch (messageType) {
					case MAP_CANCEL_LOCATION_RES:
					case MAP_PURGE_MS_RES:
					case MAP_UPDATE_GPRS_LOCATION_RES:
					case MAP_SEND_AUTHENTICATION_INFO_RES:
					case MAP_INSERT_SUBSCRIBER_DATA_RES:
					case MAP_DELETE_SUBSCRIBER_DATA_RES:
					case MAP_SEND_ROUTING_INFO_FOR_GPRS_RES:
					case MAP_FAILURE_REPORT_RES:
					case MAP_NOTE_MS_PRESENT_FOR_GPRS_RES:
						op_pk_nfd_get(pkptr, "userError", &userError);
						if (userError!=0) {
							tc_u_reject_req_pkptr = op_pk_create_fmt("TC_U_REJECT_req");
							op_pk_nfd_set(tc_u_reject_req_pkptr, "problemCode",userError);
							op_pk_send(tc_u_reject_req_pkptr, MAP_SGSN_OUT_STRM);
						} else {
							tc_continue_req_pkptr = op_pk_create_fmt("TC_CONTINUE_req");
							op_pk_send(tc_continue_req_pkptr, MAP_SGSN_OUT_STRM);
							tc_result_l_req_pkptr = op_pk_create_fmt("TC_RESULT_L_req");
							op_pk_nfd_set(tc_result_l_req_pkptr, "operation",messageType);
							op_pk_nfd_set(tc_result_l_req_pkptr, "mapPDU",pkptr);
							op_pk_send(tc_result_l_req_pkptr, MAP_SGSN_OUT_STRM);
						}
						break;
					default:
						break;
				}
				}
				}
				FSM_PROFILE_SECTION_OUT ("hlr_map_performing_ssm_process_model [WAIT_FOR_RESPONSE exit execs]", state1_exit_exec)


			/** state (WAIT_FOR_RESPONSE) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "WAIT_FOR_RESPONSE", "IDLE")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,hlr_map_performing_ssm_process_model)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
hlr_map_performing_ssm_process_model_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (hlr_map_performing_ssm_process_model_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (hlr_map_performing_ssm_process_model)",
			sizeof (hlr_map_performing_ssm_process_model_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((hlr_map_performing_ssm_process_model_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
hlr_map_performing_ssm_process_model_diag (void)
	{
	/* No Diagnostic Block */
	}




void
hlr_map_performing_ssm_process_model_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (hlr_map_performing_ssm_process_model_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}




void
hlr_map_performing_ssm_process_model_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{

	FIN (hlr_map_performing_ssm_process_model_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

