/* Process model C form file: hlr_map_requesting_ssm_process_model.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char hlr_map_requesting_ssm_process_model_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3ECB39C4 3ECB39C4 1 luna vladimir 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                          ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "map.h"

// Definitions of packet streams

#define MAP_DSM_IN_STRM 0
#define MAP_USER_OUT_STRM 0
#define MAP_SGSN_OUT_STRM 1
#define MAP_GGSN_OUT_STRM 2

#define CNF_NEADED cnfNeaded
#define RSM_TIMEOUT 30
#define RSM_TIMER_EXPIRED 8
#define PARTIAL_RESULT_RCVD (op_intrpt_type() == \
OPC_INTRPT_STRM && messageType == TC_RESULT_NL_IND)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		operation;
	} hlr_map_requesting_ssm_process_model_state;

#define pr_state_ptr            		((hlr_map_requesting_ssm_process_model_state*) SimI_Mod_State_Ptr)
#define operation               		pr_state_ptr->operation

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	hlr_map_requesting_ssm_process_model_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void hlr_map_requesting_ssm_process_model (void);
	Compcode hlr_map_requesting_ssm_process_model_init (void **);
	void hlr_map_requesting_ssm_process_model_diag (void);
	void hlr_map_requesting_ssm_process_model_terminate (void);
	void hlr_map_requesting_ssm_process_model_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
hlr_map_requesting_ssm_process_model (void)
	{
	int _block_origin = 0;
	FIN (hlr_map_requesting_ssm_process_model ());
	if (1)
		{
		Packet* pkptr;
		int cnfNeaded = 0;
		int messageType;
		int intrpt_type;


		FSM_ENTER (hlr_map_requesting_ssm_process_model)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (IDLE) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, state0_enter_exec, "IDLE", "hlr_map_requesting_ssm_process_model [IDLE enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_requesting_ssm_process_model [IDLE enter execs]", state0_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("hlr_map_requesting_ssm_process_model [IDLE enter execs]", state0_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,hlr_map_requesting_ssm_process_model)


			/** state (IDLE) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "IDLE", "hlr_map_requesting_ssm_process_model [IDLE exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_requesting_ssm_process_model [IDLE exit execs]", state0_exit_exec)
				{
				Packet* tc_invoke_req_pkptr;
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
				pkptr = op_pk_get(op_intrpt_strm());
				op_pk_nfd_get(pkptr, "messageType", &messageType);
				switch (messageType) {
					case MAP_CANCEL_LOCATION_REQ:
					case MAP_PURGE_MS_REQ:
					case MAP_UPDATE_GPRS_LOCATION_REQ:
					case MAP_SEND_AUTHENTICATION_INFO_REQ:
					case MAP_INSERT_SUBSCRIBER_DATA_REQ:
					case MAP_DELETE_SUBSCRIBER_DATA_REQ:
					case MAP_RESET_REQ:
					case MAP_SEND_ROUTING_INFO_FOR_GPRS_REQ:
					case MAP_FAILURE_REPORT_REQ:
					case MAP_NOTE_MS_PRESENT_FOR_GPRS_REQ:
						tc_invoke_req_pkptr = op_pk_create_fmt("TC_INVOKE_req");
						op_pk_nfd_set(tc_invoke_req_pkptr, "operation", messageType);
						op_pk_nfd_set(tc_invoke_req_pkptr, "mapPDU", pkptr);
						op_pk_send(tc_invoke_req_pkptr, MAP_SGSN_OUT_STRM);
						if (messageType != MAP_RESET_REQ) {cnfNeaded = 1; operation = messageType;}
						break;
					default:
						break;
				}
				}
				}
				FSM_PROFILE_SECTION_OUT ("hlr_map_requesting_ssm_process_model [IDLE exit execs]", state0_exit_exec)


			/** state (IDLE) transition processing **/
			FSM_PROFILE_SECTION_IN ("hlr_map_requesting_ssm_process_model [IDLE trans conditions]", state0_trans_conds)
			FSM_INIT_COND (CNF_NEADED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("IDLE")
			FSM_PROFILE_SECTION_OUT ("hlr_map_requesting_ssm_process_model [IDLE trans conditions]", state0_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "CNF_NEADED", "", "IDLE", "WAIT_CNF")
				FSM_CASE_TRANSIT (1, 0, state0_enter_exec, ;, "default", "", "IDLE", "IDLE")
				}
				/*---------------------------------------------------------*/



			/** state (WAIT_CNF) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "WAIT_CNF", "hlr_map_requesting_ssm_process_model [WAIT_CNF enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_requesting_ssm_process_model [WAIT_CNF enter execs]", state1_enter_exec)
				{
				//op_intrpt_schedule_self(op_sim_time() + RSM_TIMEOUT, RSM_TIMER_EXPIRED);
				}

				FSM_PROFILE_SECTION_OUT ("hlr_map_requesting_ssm_process_model [WAIT_CNF enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,hlr_map_requesting_ssm_process_model)


			/** state (WAIT_CNF) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "WAIT_CNF", "hlr_map_requesting_ssm_process_model [WAIT_CNF exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_map_requesting_ssm_process_model [WAIT_CNF exit execs]", state1_exit_exec)
				{
				int error;
				Packet* map_cnf_pkptr;
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
				switch (operation) {
					case MAP_CANCEL_LOCATION_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_CANCEL_LOCATION_con");
						break;
					case MAP_PURGE_MS_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_PURGE_MS_con");
						break;
					case MAP_SEND_AUTHENTICATION_INFO_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_SEND_AUTHENTICATION_INFO_con");
						break;
					case MAP_UPDATE_GPRS_LOCATION_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_UPDATE_GPRS_LOCATION_con");
						break;
					case MAP_INSERT_SUBSCRIBER_DATA_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_INSERT_SUBSCRIBER_DATA_con");
						break;
					case MAP_DELETE_SUBSCRIBER_DATA_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_DELETE_SUBSCRIBER_DATA_con");
						break;
					case MAP_NOTE_MS_PRESENT_FOR_GPRS_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_NOTE_MS_PRESENT_FOR_GPRS_con");
						break;
					case MAP_SEND_ROUTING_INFO_FOR_GPRS_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_SEND_ROUTING_INFO_FOR_GPRS_con");
						break;
					case MAP_FAILURE_REPORT_REQ:
						map_cnf_pkptr = op_pk_create_fmt("MAP_FAILURE_REPORT_con");
						break;
					default:
						break;
				}
				pkptr = op_pk_get(op_intrpt_strm());
				op_pk_nfd_get(pkptr, "messageType", &messageType);
				switch (messageType) {
					case TC_RESULT_L_IND:
						op_pk_send(map_cnf_pkptr, MAP_USER_OUT_STRM);
						break;
					case TC_U_ERROR_IND:
						op_pk_nfd_get(pkptr,"error", &error);
						op_pk_nfd_set(map_cnf_pkptr,"userError", error);
						op_pk_send(map_cnf_pkptr, MAP_USER_OUT_STRM);
						break;
					case TC_U_REJECT_IND:
						op_pk_nfd_get(pkptr, "problemCode", &error);
						op_pk_nfd_set(map_cnf_pkptr,"userError", error);	
						op_pk_send(map_cnf_pkptr, MAP_USER_OUT_STRM);
						break;
					default:
						break;
					}
				}
				}
				FSM_PROFILE_SECTION_OUT ("hlr_map_requesting_ssm_process_model [WAIT_CNF exit execs]", state1_exit_exec)


			/** state (WAIT_CNF) transition processing **/
			FSM_PROFILE_SECTION_IN ("hlr_map_requesting_ssm_process_model [WAIT_CNF trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PARTIAL_RESULT_RCVD)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("WAIT_CNF")
			FSM_PROFILE_SECTION_OUT ("hlr_map_requesting_ssm_process_model [WAIT_CNF trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "PARTIAL_RESULT_RCVD", "", "WAIT_CNF", "WAIT_CNF")
				FSM_CASE_TRANSIT (1, 0, state0_enter_exec, ;, "default", "", "WAIT_CNF", "IDLE")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,hlr_map_requesting_ssm_process_model)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
hlr_map_requesting_ssm_process_model_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (hlr_map_requesting_ssm_process_model_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (hlr_map_requesting_ssm_process_model)",
			sizeof (hlr_map_requesting_ssm_process_model_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((hlr_map_requesting_ssm_process_model_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
hlr_map_requesting_ssm_process_model_diag (void)
	{
	/* No Diagnostic Block */
	}




void
hlr_map_requesting_ssm_process_model_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (hlr_map_requesting_ssm_process_model_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in hlr_map_requesting_ssm_process_model_svar function. */
#undef operation



void
hlr_map_requesting_ssm_process_model_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	hlr_map_requesting_ssm_process_model_state		*prs_ptr;

	FIN (hlr_map_requesting_ssm_process_model_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (hlr_map_requesting_ssm_process_model_state *)gen_ptr;

	if (strcmp ("operation" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->operation);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

