/* Process model C form file: mjohanss_pc_prio.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char mjohanss_pc_prio_pr_c [] = "MIL_3_Tfile_Hdr_ 90A 30A opnet 7 3E77A86A 3E77A86A 1 payette mjohanss 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                       ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#define BUF_TO_LOWERLAYER 0
#define MUX_TO_BUF 0

#define ARRIVAL     op_intrpt_type () == OPC_INTRPT_STRM
#define SERVICE     op_intrpt_type () == OPC_INTRPT_ACCESS



/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	} mjohanss_pc_prio_state;

#define pr_state_ptr            		((mjohanss_pc_prio_state*) SimI_Mod_State_Ptr)

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	mjohanss_pc_prio_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void mjohanss_pc_prio (void);
	Compcode mjohanss_pc_prio_init (void **);
	void mjohanss_pc_prio_diag (void);
	void mjohanss_pc_prio_terminate (void);
	void mjohanss_pc_prio_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
mjohanss_pc_prio (void)
	{
	int _block_origin = 0;
	FIN (mjohanss_pc_prio ());
	if (1)
		{
		Packet          *pkptr;


		FSM_ENTER (mjohanss_pc_prio)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (INS_PRIO) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, state0_enter_exec, "INS_PRIO", "mjohanss_pc_prio [INS_PRIO enter execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [INS_PRIO enter execs]", state0_enter_exec)
				{
				/* a new packet has arrived; acquire it */
				pkptr = op_pk_get (op_intrpt_strm ());
				
				/* insert the new packet according to priority in subqueue 0 */
				if (op_subq_pk_insert (0, pkptr, OPC_QPOS_PRIO) != OPC_QINS_OK)
					{
					/* if the insertion failed, discard the packet */
					op_pk_destroy (pkptr);
					printf("MUX_PRIO_QUEUE: insert packet FAILED\n");
					}
				//printf("MUX_PRIO_QUEUE: packet inserted\n");
				}

				FSM_PROFILE_SECTION_OUT ("mjohanss_pc_prio [INS_PRIO enter execs]", state0_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,mjohanss_pc_prio)


			/** state (INS_PRIO) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "INS_PRIO", "mjohanss_pc_prio [INS_PRIO exit execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [INS_PRIO exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("mjohanss_pc_prio [INS_PRIO exit execs]", state0_exit_exec)


			/** state (INS_PRIO) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "INS_PRIO", "BRANCH")
				/*---------------------------------------------------------*/



			/** state (SEND_HEAD) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "SEND_HEAD", "mjohanss_pc_prio [SEND_HEAD enter execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [SEND_HEAD enter execs]", state1_enter_exec)
				{
				/* a request has been made to access the queue */
				/* check if its empty */
				if (!op_subq_empty (0))
				    {
				    /* access the first packet in the subqueue */
				    pkptr = op_subq_pk_remove (0, OPC_QPOS_HEAD);
				
					/* forward it to the destination */
					//printf("MUX_PRIO_QUEUE: Packet forwarded\n");
				    op_pk_send (pkptr, BUF_TO_LOWERLAYER);
				    }
				}

				FSM_PROFILE_SECTION_OUT ("mjohanss_pc_prio [SEND_HEAD enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,mjohanss_pc_prio)


			/** state (SEND_HEAD) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "SEND_HEAD", "mjohanss_pc_prio [SEND_HEAD exit execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [SEND_HEAD exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("mjohanss_pc_prio [SEND_HEAD exit execs]", state1_exit_exec)


			/** state (SEND_HEAD) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "SEND_HEAD", "BRANCH")
				/*---------------------------------------------------------*/



			/** state (BRANCH) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "BRANCH", "mjohanss_pc_prio [BRANCH enter execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [BRANCH enter execs]", state2_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("mjohanss_pc_prio [BRANCH enter execs]", state2_enter_exec)

			/** state (BRANCH) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "BRANCH", "mjohanss_pc_prio [BRANCH exit execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [BRANCH exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("mjohanss_pc_prio [BRANCH exit execs]", state2_exit_exec)


			/** state (BRANCH) transition processing **/
			FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [BRANCH trans conditions]", state2_trans_conds)
			FSM_INIT_COND (SERVICE)
			FSM_TEST_COND (ARRIVAL)
			FSM_TEST_LOGIC ("BRANCH")
			FSM_PROFILE_SECTION_OUT ("mjohanss_pc_prio [BRANCH trans conditions]", state2_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "SERVICE", "", "BRANCH", "SEND_HEAD")
				FSM_CASE_TRANSIT (1, 0, state0_enter_exec, ;, "ARRIVAL", "", "BRANCH", "INS_PRIO")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (2,mjohanss_pc_prio)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
mjohanss_pc_prio_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (mjohanss_pc_prio_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (mjohanss_pc_prio)",
			sizeof (mjohanss_pc_prio_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((mjohanss_pc_prio_state *)(*gen_state_pptr))->current_block = 4;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
mjohanss_pc_prio_diag (void)
	{
	/* No Diagnostic Block */
	}




void
mjohanss_pc_prio_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (mjohanss_pc_prio_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}




void
mjohanss_pc_prio_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{

	FIN (mjohanss_pc_prio_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

