/* Process model C form file: ms_process_model.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char ms_process_model_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3ECB4F7C 3ECB4F7C 1 luna vladimir 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                          ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "gprs_llc.h"
#include "msRecord.h"

//incoming
#define GMM_RCV_IN_STRM 0
 
#define ATTACH_SRC_IN_STRM 1
#define DETACH_SRC_IN_STRM 2
#define ACTIVATION_SRC_IN_STRM 3
#define DEACTIVATION_SRC_IN_STRM 4
#define USER_DATA_SRC_IN_STRM 5

//outgoing
#define GMM_XMT_OUT_STRM 0

#define USER_DATA_XMT_OUT_STRM 1 
#define GMM_TO_LLME 2 


#define ATTACH_ACCEPT 0x02
#define DETACH_ACCEPT 0x06
#define ATTACH_REJECT 0x04

/* transition macros */
#define DETACH_SRC_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == DETACH_SRC_IN_STRM)

/* transition macros */
#define ATTACH_SRC_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == ATTACH_SRC_IN_STRM)

#define GMM_RCV_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == GMM_RCV_IN_STRM)



#define ACTIVATION_ACCEPT 66
#define ACTIVATION_REJECT 67
#define DEACTIVATION_ACCEPT 71


/* transition macros */
#define ACTIVATION_SRC_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == ACTIVATION_SRC_IN_STRM)


/* transition macros */
#define DEACTIVATION_SRC_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == DEACTIVATION_SRC_IN_STRM)

/* transition macros */
#define USER_DATA_SRC_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == USER_DATA_SRC_IN_STRM)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Distribution *	         		imsi_distribution;
	Stathandle	             		detachProcessTime_gsh;
	char	                   		debugStr[1000];
	Stathandle	             		attachProcessTime_gsh;
	Stathandle	             		activationProcessTime_gsh;
	Stathandle	             		deactivationProcessTime_gsh;
	MSStatus	               		msStatus[100];
	Stathandle	             		tlliInAttachReject_gsh;
	Stathandle	             		tlliInActivateReject_gsh;
	Stathandle	             		rejectCauseInActivation_gsh;
	} ms_process_model_state;

#define pr_state_ptr            		((ms_process_model_state*) SimI_Mod_State_Ptr)
#define imsi_distribution       		pr_state_ptr->imsi_distribution
#define detachProcessTime_gsh   		pr_state_ptr->detachProcessTime_gsh
#define debugStr                		pr_state_ptr->debugStr
#define attachProcessTime_gsh   		pr_state_ptr->attachProcessTime_gsh
#define activationProcessTime_gsh		pr_state_ptr->activationProcessTime_gsh
#define deactivationProcessTime_gsh		pr_state_ptr->deactivationProcessTime_gsh
#define msStatus                		pr_state_ptr->msStatus
#define tlliInAttachReject_gsh  		pr_state_ptr->tlliInAttachReject_gsh
#define tlliInActivateReject_gsh		pr_state_ptr->tlliInActivateReject_gsh
#define rejectCauseInActivation_gsh		pr_state_ptr->rejectCauseInActivation_gsh

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	ms_process_model_state *op_sv_ptr = pr_state_ptr;


/* Function Block */

enum { _block_origin = __LINE__ };
ms_llc_init()
{	
Packet *my_packet_ptr;
Packet *l3_pdu_ptr;
Packet *out_packet_ptr;
int result;
int i;

FIN (ms_llc_init ());
// initialize the state variables for each MS (imsi).
for (i=0; i < MAX_SUPPORTED_MS; i++)
	{
		//printf("MS layer 3: BEFORE GENERATE gprs_LLGMM_ASSIGN_REQ\n");
		my_packet_ptr=generate("gprs_LLGMM_ASSIGN_REQ");
		op_pk_nfd_set(my_packet_ptr, "message_type", gprs_LLGMM_ASSIGN_REQ); //message_type=10
		op_pk_nfd_set(my_packet_ptr, "tlli_old", i);
		op_pk_nfd_set(my_packet_ptr, "tlli_new", i);
		op_pk_nfd_set(my_packet_ptr, "imsi", i);
		//printf("MS Layer 3: AFTER GENERATE gprs_LLGMM_ASSIGN_REQ  \n");
		if (my_packet_ptr==OPC_NIL) 
			{
				printf("MS layer 3: pkptr=NIL\n");
			}
		else
			{
				op_pk_send(my_packet_ptr, GMM_TO_LLME);
				//printf("MS layer 3:  gprs_LLGMM_ASSIGN_REQ SENT TO LLME\n");
			} 		
	 } 
FRET ();	
}


//***************************************************************************
static Packet* generate (char packet_type[30])
	{
	Packet*				pkptr;
	double				pksize;
   
	FIN (generate ());

	
	/* Create a formatted packet */
	pkptr = op_pk_create_fmt (packet_type);
	
	
	FRET (pkptr);

	}	


//***************************************************************************
 Packet* ms_LLC_service_encap (Packet * pdu_ptr, int tlli, int my_prec_class )
	{
	int result;
	Packet *out_packet_ptr;
	
	FIN (ms_LLC_service_encap ());
	

	if (pdu_ptr==OPC_NIL)
		{
	   		printf("MS: pdu_ptr = NIL \n");
			}
	else
		{
			//printf("MS layer 3: BEFORE GENERATE gprs_LL_UNITDATA_REQ\n");
			out_packet_ptr=generate("gprs_LL_UNITDATA_REQ");
			//printf("MS layer 3: AFTER GENERATE gprs_LL_UNITDATA_REQ  \n");
			op_pk_nfd_set(out_packet_ptr, "message_type",gprs_LL_UNITDATA_REQ ); 
			op_pk_nfd_set(out_packet_ptr, "imsi", tlli);
			result=op_pk_nfd_set(out_packet_ptr, "l3_pdu", pdu_ptr );
			//printf("MS: result after setting l3_pdu: ");
			//printf("%d\n", result);
			op_pk_nfd_set(out_packet_ptr, "tlli", tlli);
			
			//IN LLC prec.class values are 1=HIGH , 2=NORMAL, 3=LOW
			op_pk_nfd_set(out_packet_ptr, "precedence_class", my_prec_class );
			if (out_packet_ptr==OPC_NIL) 
				{
					//printf("MS layer 3: LL_UNITDATA_REQ pkptr=NIL\n");
				}	
			else
				{
					FRET (out_packet_ptr);
				}
		 }
	  }	

 
 //***************************************************************************
 Packet* ms_LLC_service_decap (Packet * in_packet_ptr)
	{
	int result;
	Packet *l3_pdu_ptr;
	
	FIN (ms_LLC_service_decap ());
	
	if (in_packet_ptr==OPC_NIL)
		{
	   		printf("SGSN LAYER 3: packet_ptr = NIL \n");
			}
	else
		{
			//printf("MS layer 3: BEFORE DECAP l3_pdu from service primitive \n");
			result=op_pk_nfd_get(in_packet_ptr, "l3_pdu", &l3_pdu_ptr );
			//printf("MS layer 3: result after getting l3_pdu: ");
			//printf("%d\n", result);
			if (l3_pdu_ptr==OPC_NIL) 
				{
					printf("MS layer 3: LL_UNITDATA_IND pkptr=NIL\n");
				}	
			else
				{
					FRET (l3_pdu_ptr);
				}
		 }
	  }	

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void ms_process_model (void);
	Compcode ms_process_model_init (void **);
	void ms_process_model_diag (void);
	void ms_process_model_terminate (void);
	void ms_process_model_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
ms_process_model (void)
	{
	int _block_origin = 0;
	FIN (ms_process_model ());
	if (1)
		{
		Packet *pkptr;
		
		double detachProcessTime;
		double attachProcessTime;
		double activationProcessTime;
		double deactivationProcessTime;
		double sentTime;


		FSM_ENTER (ms_process_model)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "ms_process_model [init enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [init enter execs]", state0_enter_exec)
				{
				// initialize the msStatus state variable
				int i;
				
				// currently supports only MAX_SUPPRORTED_MS subscribers
				imsi_distribution = op_dist_load ("uniform_int", 0, MAX_SUPPORTED_MS-1);
				attachProcessTime_gsh = op_stat_reg ("Attach Process Time",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				deactivationProcessTime_gsh = op_stat_reg ("Deactivation Process Time",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				activationProcessTime_gsh = op_stat_reg ("Activation Process Time",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				detachProcessTime_gsh = op_stat_reg ("Detach Process Time",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				
				tlliInAttachReject_gsh = op_stat_reg ("TLLI in Attach Reject",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				
				tlliInActivateReject_gsh = op_stat_reg ("TLLI in Activate Reject",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				
				rejectCauseInActivation_gsh = op_stat_reg ("Reject Cause in Activate Reject",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				
				for (i=0; i < MAX_SUPPORTED_MS; i++)
					{
					    msStatus[i].status = MSStatus_Detached;
					}
				
				ms_llc_init();
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "ms_process_model [init exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "ms_process_model [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [idle enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,ms_process_model)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "ms_process_model [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [idle exit execs]", state1_exit_exec)
				{
				int intrpt_type;
				int i;
				
				/* Determine the interrupt type as the model perform .	*/
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_ENDSIM)
					{	
					printf("State information of MS after simulation, 0 = Detached, 1 = Attached, 2 = Activated\n");
					for (i=0; i <= 12; i++)
						{
						printf("IMSI:   %d\tMM State: %d\n", i, msStatus[i].status);
						}
					}
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [idle exit execs]", state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("ms_process_model [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (ATTACH_SRC_ARRIVAL)
			FSM_TEST_COND (GMM_RCV_ARRIVAL)
			FSM_TEST_COND (ACTIVATION_SRC_ARRIVAL)
			FSM_TEST_COND (DEACTIVATION_SRC_ARRIVAL)
			FSM_TEST_COND (DETACH_SRC_ARRIVAL)
			FSM_TEST_COND (USER_DATA_SRC_ARRIVAL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("ms_process_model [idle trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "ATTACH_SRC_ARRIVAL", "", "idle", "attachXmt")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "GMM_RCV_ARRIVAL", "", "idle", "gmmMsgRcv")
				FSM_CASE_TRANSIT (2, 4, state4_enter_exec, ;, "ACTIVATION_SRC_ARRIVAL", "", "idle", "activationXmt")
				FSM_CASE_TRANSIT (3, 5, state5_enter_exec, ;, "DEACTIVATION_SRC_ARRIVAL", "", "idle", "deactivationXmt")
				FSM_CASE_TRANSIT (4, 6, state6_enter_exec, ;, "DETACH_SRC_ARRIVAL", "", "idle", "detachXmt")
				FSM_CASE_TRANSIT (5, 7, state7_enter_exec, ;, "USER_DATA_SRC_ARRIVAL", "", "idle", "userDataXmt")
				FSM_CASE_TRANSIT (6, 1, state1_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (attachXmt) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "attachXmt", "ms_process_model [attachXmt enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [attachXmt enter execs]", state2_enter_exec)
				{
				int imsi;
				pkptr = op_pk_get (ATTACH_SRC_IN_STRM);
				
				// set the imsi of the MS
				imsi = (int)op_dist_outcome(imsi_distribution);
				//Added by Mikael: SET imsi to 5 always to simulate only one MS
				imsi=5;
				
				op_pk_nfd_set (pkptr, "imsi",
					imsi);
				
				// send the attach only if MS status is detached
				if (msStatus[imsi].status == MSStatus_Detached)
					{
					
					//Added my Mikael: encapsulates layer 3 packet in LLC service primitive
					//LL_UNITDATA_REQ. Prio will be set to High (001)
					pkptr=ms_LLC_service_encap(pkptr, imsi, 1);
					
				    op_pk_send(pkptr, GMM_XMT_OUT_STRM);
					//printf("MS layer 3: PACKET sent with imsi: \n");
					//printf("%d\n", imsi);
					
					sentTime = op_sim_time ();
					// set the attach request sent time
				    msStatus[imsi].attachReqSentTime = sentTime;
					}
				else
					{
					op_pk_destroy(pkptr);
					}
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [attachXmt enter execs]", state2_enter_exec)

			/** state (attachXmt) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "attachXmt", "ms_process_model [attachXmt exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [attachXmt exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [attachXmt exit execs]", state2_exit_exec)


			/** state (attachXmt) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "attachXmt", "idle")
				/*---------------------------------------------------------*/



			/** state (gmmMsgRcv) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "gmmMsgRcv", "ms_process_model [gmmMsgRcv enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [gmmMsgRcv enter execs]", state3_enter_exec)
				{
				double detachReqSentTime;
				double attachReqSentTime;
				Packet * attachCompletePkPtr;
				int messageType;
				int tlli;
				
				double activationReqSentTime;
				double deactivationReqSentTime;
				int smCause;
				
				pkptr = op_pk_get(GMM_RCV_IN_STRM);
				
				//Decapsulate layer 3 packet from LL_UNITDATA_IND service primitive
				//received from LLC
				pkptr=ms_LLC_service_decap(pkptr);
					
				// retrieve the message type of message sent by SGSN
				op_pk_nfd_get (pkptr, "messageType", &messageType);
				
				
				switch (messageType) {
				    case ATTACH_ACCEPT:
				                
					    // retrieve the allocatedPTMSI from attach accept
					    op_pk_nfd_get(pkptr, "allocatedPTMSI", &tlli);
				        // reply SGSN with AttachComplete
					    attachCompletePkPtr = op_pk_create_fmt ("attachComplete");
					    op_pk_nfd_set(attachCompletePkPtr, "TLLI", tlli);
					
						//Added my Mikael: encapsulates layer 3 packet in LLC service primitive
						//LL_UNITDATA_REQ. Prio will be set to High (001)
						attachCompletePkPtr=ms_LLC_service_encap(attachCompletePkPtr, tlli, 1);
					
					    op_pk_send(attachCompletePkPtr, GMM_XMT_OUT_STRM);
					
					     // change the msStatus to MS_ATTACHED
					     msStatus[tlli].status = MSStatus_Attached;
					     
					     // record attachProcessTime
					     attachProcessTime = op_sim_time() - msStatus[tlli].attachReqSentTime;
				         op_stat_write(attachProcessTime_gsh, attachProcessTime);
					
					    break;
				    case DETACH_ACCEPT:	    
				
					    // retrieve the tlli from detach accept
					    op_pk_nfd_get(pkptr, "TLLI", &tlli); 
				        //sprintf (debugStr, "Detach Accept Recv. Detach Req sent time %f", detachReqSentTime);
				        //op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				        //sprintf (debugStr, "Detach Accept Recv. Detach Accept Recv time %f", op_sim_time());
				        //op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
					
					    // change the msStatus to MS_DETACHED
					    msStatus[tlli].status = MSStatus_Detached;
								 
						// record detachProcessTime
				        detachProcessTime = op_sim_time() - msStatus[tlli].detachReqSentTime;
				        op_stat_write(detachProcessTime_gsh, detachProcessTime);
				        break;
				    case ATTACH_REJECT:	    
				
					    // retrieve the tlli from attach reject
					    op_pk_nfd_get(pkptr, "TLLI", &tlli); 
				        
				        op_stat_write(tlliInAttachReject_gsh, tlli);
				        break;
					case ACTIVATION_ACCEPT:
						// retrieve the tlli  
						op_pk_nfd_get(pkptr, "TLLI", &tlli);
				        sprintf (debugStr, "Activation Accept Recv. Activation Req sent time %f", activationReqSentTime);
				        //op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				        sprintf (debugStr, "Activation Accept Recv. Activation Accept Recv time %f", op_sim_time());
				        //op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
					
					    // change the msStatus to MS_ACTIVATED
					    msStatus[tlli].status = MSStatus_Activated;
					
					    // record activationProcessTime
				        activationProcessTime = op_sim_time() - msStatus[tlli].activationReqSentTime;
				        op_stat_write(activationProcessTime_gsh, activationProcessTime); 
				        break;
					case DEACTIVATION_ACCEPT:
						// retrieve the tlli 
						op_pk_nfd_get(pkptr, "TLLI", &tlli);
					    // change the msStatus to MS_ATTACHED
					    msStatus[tlli].status = MSStatus_Attached;
												  
				        // record deactivationProcessTime
						deactivationProcessTime = op_sim_time() - msStatus[tlli].deactivationReqSentTime;
				        op_stat_write(deactivationProcessTime_gsh, deactivationProcessTime);	
					
					    break;
					case ACTIVATION_REJECT:  
					    // retrieve the tlli 
						op_pk_nfd_get(pkptr, "TLLI", &tlli);
						op_pk_nfd_get(pkptr, "smCause", 
				                &smCause);						  
					    op_stat_write(rejectCauseInActivation_gsh, smCause);
				        // record the imis in Activation Reject
				        if (smCause == 30)
							{	
							op_stat_write(tlliInActivateReject_gsh, tlli);	
							}
					
					    break;
					default:
					    break;
					}
				op_pk_destroy(pkptr);
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [gmmMsgRcv enter execs]", state3_enter_exec)

			/** state (gmmMsgRcv) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "gmmMsgRcv", "ms_process_model [gmmMsgRcv exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [gmmMsgRcv exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [gmmMsgRcv exit execs]", state3_exit_exec)


			/** state (gmmMsgRcv) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "gmmMsgRcv", "idle")
				/*---------------------------------------------------------*/



			/** state (activationXmt) enter executives **/
			FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "activationXmt", "ms_process_model [activationXmt enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [activationXmt enter execs]", state4_enter_exec)
				{
				int tlli;
				
				pkptr = op_pk_get (ACTIVATION_SRC_IN_STRM);
				
				//sprintf (debugStr, "Activation Req sent.  Activation Req sent time %f", sentTime);
				//op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				// set the tlli of the MS
				tlli = (int)op_dist_outcome(imsi_distribution);
				//Added by Mikael: Always set till to 5 to simulate only one MS
				tlli=5;
				
				op_pk_nfd_set (pkptr, "TLLI",
					tlli);
				
				// send Activate PDP Request only if the MS is attached 
				if (msStatus[tlli].status == MSStatus_Attached)
					{
					//Added my Mikael: encapsulates layer 3 packet in LLC service primitive
					//LL_UNITDATA_REQ. Prio will be set to High (001)
					pkptr=ms_LLC_service_encap(pkptr, tlli, 1);
					
				    op_pk_send(pkptr, GMM_XMT_OUT_STRM);
					sentTime = op_sim_time ();
					// set the activation request sent time
				    msStatus[tlli].activationReqSentTime = sentTime;
					}
				else
					{
					op_pk_destroy(pkptr);
					}
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [activationXmt enter execs]", state4_enter_exec)

			/** state (activationXmt) exit executives **/
			FSM_STATE_EXIT_FORCED (4, "activationXmt", "ms_process_model [activationXmt exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [activationXmt exit execs]", state4_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [activationXmt exit execs]", state4_exit_exec)


			/** state (activationXmt) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "activationXmt", "idle")
				/*---------------------------------------------------------*/



			/** state (deactivationXmt) enter executives **/
			FSM_STATE_ENTER_FORCED (5, state5_enter_exec, "deactivationXmt", "ms_process_model [deactivationXmt enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [deactivationXmt enter execs]", state5_enter_exec)
				{
				int tlli;
				
				pkptr = op_pk_get (DEACTIVATION_SRC_IN_STRM);
				
				// set the tlli of the MS
				tlli = (int)op_dist_outcome(imsi_distribution);
				//Added by Mikael: SET imsi to 6 always to simulate only one MS
				tlli=5;
				
				
				op_pk_nfd_set (pkptr, "TLLI",
					tlli);
				
				// send Deactivate PDP Request only if the MS is activated 
				if (msStatus[tlli].status == MSStatus_Activated)
					{
					
					//Added my Mikael: encapsulates layer 3 packet in LLC service primitive
					//LL_UNITDATA_REQ. Prio will be set to High (001)
					pkptr=ms_LLC_service_encap(pkptr, tlli, 1);
					
				    op_pk_send(pkptr, GMM_XMT_OUT_STRM);
					sentTime = op_sim_time ();
					// set the deactivation request sent time
				    msStatus[tlli].deactivationReqSentTime = sentTime;
					}
				else
					{
					op_pk_destroy(pkptr);
					}
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [deactivationXmt enter execs]", state5_enter_exec)

			/** state (deactivationXmt) exit executives **/
			FSM_STATE_EXIT_FORCED (5, "deactivationXmt", "ms_process_model [deactivationXmt exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [deactivationXmt exit execs]", state5_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [deactivationXmt exit execs]", state5_exit_exec)


			/** state (deactivationXmt) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "deactivationXmt", "idle")
				/*---------------------------------------------------------*/



			/** state (detachXmt) enter executives **/
			FSM_STATE_ENTER_FORCED (6, state6_enter_exec, "detachXmt", "ms_process_model [detachXmt enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [detachXmt enter execs]", state6_enter_exec)
				{
				int tlli;
				
				pkptr = op_pk_get(DETACH_SRC_IN_STRM);
				//sprintf (debugStr, "Detach Req sent.  Detach Req sent time %f", sentTime);
				//op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				// set the tlli of the MS
				tlli = (int)op_dist_outcome(imsi_distribution);
				
				//Added by Mikael: SET imsi to 6 always to simulate only one MS
				tlli=5;
				
				op_pk_nfd_set (pkptr, "TLLI",
					tlli);
				
				
				// send Detach Request only if the MS is attached or 
				// activated
				if ( (msStatus[tlli].status == MSStatus_Attached) ||
				    (msStatus[tlli].status == MSStatus_Activated) )
					{
					//Added my Mikael: encapsulates layer 3 packet in LLC service primitive
					//LL_UNITDATA_REQ. Prio will be set to High (001)
					pkptr=ms_LLC_service_encap(pkptr, tlli, 1);
					
					op_pk_send(pkptr, GMM_XMT_OUT_STRM);
					sentTime = op_sim_time ();
					// set the detach request sent time
				    msStatus[tlli].detachReqSentTime = sentTime;
					}
				else
					{
					op_pk_destroy(pkptr);
					}
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [detachXmt enter execs]", state6_enter_exec)

			/** state (detachXmt) exit executives **/
			FSM_STATE_EXIT_FORCED (6, "detachXmt", "ms_process_model [detachXmt exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [detachXmt exit execs]", state6_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [detachXmt exit execs]", state6_exit_exec)


			/** state (detachXmt) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "detachXmt", "idle")
				/*---------------------------------------------------------*/



			/** state (userDataXmt) enter executives **/
			FSM_STATE_ENTER_FORCED (7, state7_enter_exec, "userDataXmt", "ms_process_model [userDataXmt enter execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [userDataXmt enter execs]", state7_enter_exec)
				{
				int tlli,nsapi;
				Packet * ipDataPkPtr;
				Packet * sndcpPkPtr;
				double sndcp_header_size, ip_size;
				
				
				// retrieve pointer to ipv4 datagram packet
				pkptr = op_pk_get (USER_DATA_SRC_IN_STRM);
				
				//Set the size we want the packet to show the network (1024=864 AMR data+160 ip-header)
				//The ip-header overhead causes a data rate of 14.4 kbps instead of 12.2
				op_pk_total_size_set (pkptr, 1024);
				
				
				//tlli = (int)op_dist_outcome(imsi_distribution);
				//Added by Mikael: Always set till to 5 to simulate only one MS
				tlli=5;
				
				// transmit data only if MS status is activated
				if (msStatus[tlli].status == MSStatus_Activated)
					{	  
				    // create sndcp packet
					sndcpPkPtr = op_pk_create_fmt ("sndcpPacket");
					// set the tlli and nsapi of the packet
				    nsapi = 5;
				    op_pk_nfd_set (sndcpPkPtr, "TLLI",
					    tlli);
				    op_pk_nfd_set (sndcpPkPtr, "nsapi",
					    nsapi);
					
					sndcp_header_size= (double) op_pk_total_size_get (sndcpPkPtr);
					ip_size= (double) op_pk_total_size_get (pkptr);
					
					/*printf("MS: sndcp_header_size= ");
					printf("%f\n", sndcp_header_size);
					printf("MS: ip_size= ");
					printf("%f\n", ip_size);
					printf("MS: sndcp packet size= ");
					printf("%f\n", sndcp_header_size+ip_size);	
					*/
					
					// set the encapsulated IP packet
					op_pk_nfd_set (sndcpPkPtr, "data", pkptr);
					
					//Set the size we want the packet to show the network
					op_pk_total_size_set (sndcpPkPtr,sndcp_header_size+ip_size);
					
					
				    //Added my Mikael: encapsulates layer 3 packet in LLC service primitive
					//LL_UNITDATA_REQ. Precedence class will be set to HIGH (001)
					sndcpPkPtr=ms_LLC_service_encap(sndcpPkPtr, tlli, 1);
					
					op_pk_send(sndcpPkPtr, USER_DATA_XMT_OUT_STRM);
					//printf("MS: SNDCP packet sent \n");
					}
				else
					{
				    op_pk_destroy(pkptr);
					}
				}

				FSM_PROFILE_SECTION_OUT ("ms_process_model [userDataXmt enter execs]", state7_enter_exec)

			/** state (userDataXmt) exit executives **/
			FSM_STATE_EXIT_FORCED (7, "userDataXmt", "ms_process_model [userDataXmt exit execs]")
				FSM_PROFILE_SECTION_IN ("ms_process_model [userDataXmt exit execs]", state7_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("ms_process_model [userDataXmt exit execs]", state7_exit_exec)


			/** state (userDataXmt) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "userDataXmt", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,ms_process_model)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
ms_process_model_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (ms_process_model_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (ms_process_model)",
			sizeof (ms_process_model_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((ms_process_model_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
ms_process_model_diag (void)
	{
	/* No Diagnostic Block */
	}




void
ms_process_model_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (ms_process_model_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in ms_process_model_svar function. */
#undef imsi_distribution
#undef detachProcessTime_gsh
#undef debugStr
#undef attachProcessTime_gsh
#undef activationProcessTime_gsh
#undef deactivationProcessTime_gsh
#undef msStatus
#undef tlliInAttachReject_gsh
#undef tlliInActivateReject_gsh
#undef rejectCauseInActivation_gsh



void
ms_process_model_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	ms_process_model_state		*prs_ptr;

	FIN (ms_process_model_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (ms_process_model_state *)gen_ptr;

	if (strcmp ("imsi_distribution" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->imsi_distribution);
		FOUT
		}
	if (strcmp ("detachProcessTime_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->detachProcessTime_gsh);
		FOUT
		}
	if (strcmp ("debugStr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->debugStr);
		FOUT
		}
	if (strcmp ("attachProcessTime_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->attachProcessTime_gsh);
		FOUT
		}
	if (strcmp ("activationProcessTime_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->activationProcessTime_gsh);
		FOUT
		}
	if (strcmp ("deactivationProcessTime_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->deactivationProcessTime_gsh);
		FOUT
		}
	if (strcmp ("msStatus" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->msStatus);
		FOUT
		}
	if (strcmp ("tlliInAttachReject_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->tlliInAttachReject_gsh);
		FOUT
		}
	if (strcmp ("tlliInActivateReject_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->tlliInActivateReject_gsh);
		FOUT
		}
	if (strcmp ("rejectCauseInActivation_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rejectCauseInActivation_gsh);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

