/* Process model C form file: sgsn_map_user_process_model.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char sgsn_map_user_process_model_pr_c [] = "MIL_3_Tfile_Hdr_ 91A 30A opnet 7 3ECB3919 3ECB3919 1 luna vladimir 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                          ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "gtp.h"
#include "msRecord.h"
#include "mmContext.h"
#include "pdpContext.h"
#include "map.h"

#define MAP_DSM_OUT_STRM_TO_HLR 0
#define MAP_OUT_STRM_TO_SGSN 1

#define MAP_IN_STRM_FROM_SGSN 3
#define MAP_DSM_IN_STRM_FROM_HLR 2
#define MAP_PSM_IN_STRM_FROM_HLR 1
#define MAP_RSM_IN_STRM_FROM_HLR 0

#define ATTACH_REQUEST 0x01

/* transition macros */

#define MAP_OPEN_CNF_RCVD (op_intrpt_type () == OPC_INTRPT_STRM && \
messageType == MAP_OPEN_CNF && result == DIALOGUE_ACCEPTED)

#define FINISHED (op_intrpt_type () == OPC_INTRPT_STRM && finished)


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		context;
	} sgsn_map_user_process_model_state;

#define pr_state_ptr            		((sgsn_map_user_process_model_state*) SimI_Mod_State_Ptr)
#define context                 		pr_state_ptr->context

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	sgsn_map_user_process_model_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void sgsn_map_user_process_model (void);
	Compcode sgsn_map_user_process_model_init (void **);
	void sgsn_map_user_process_model_diag (void);
	void sgsn_map_user_process_model_terminate (void);
	void sgsn_map_user_process_model_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
sgsn_map_user_process_model (void)
	{
	int _block_origin = 0;
	FIN (sgsn_map_user_process_model ());
	if (1)
		{
		Packet *pkptr;
		int imsi;
		int appContext;
		int result;
		int messageType;
		int intrpt_type;
		int finished = 0;


		FSM_ENTER (sgsn_map_user_process_model)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, state0_enter_exec, "idle", "sgsn_map_user_process_model [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("sgsn_map_user_process_model [idle enter execs]", state0_enter_exec)
				{
				
				
				}

				FSM_PROFILE_SECTION_OUT ("sgsn_map_user_process_model [idle enter execs]", state0_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,sgsn_map_user_process_model)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "idle", "sgsn_map_user_process_model [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("sgsn_map_user_process_model [idle exit execs]", state0_exit_exec)
				{
				Packet * map_open_req_pkptr; 
				Packet * map_update_gprs_location_req_pkptr;
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
					pkptr = op_pk_get(op_intrpt_strm());
					op_pk_nfd_get(pkptr, "messageType", &messageType);
					switch (messageType) {
						case ATTACH_REQUEST:
							op_pk_nfd_get(pkptr, "imsi", &imsi);
							map_open_req_pkptr = op_pk_create_fmt ("MAP_OPEN_req");
							op_pk_nfd_set(map_open_req_pkptr, "appContext", gprsLocationUpdateContext);
							op_pk_send(map_open_req_pkptr, MAP_DSM_OUT_STRM_TO_HLR);
							map_update_gprs_location_req_pkptr = op_pk_create_fmt ("MAP_UPDATE_GPRS_LOCATION_req");
					  		op_pk_nfd_set(map_update_gprs_location_req_pkptr, "imsi", imsi);
							op_pk_send(map_update_gprs_location_req_pkptr, MAP_DSM_OUT_STRM_TO_HLR);
							break;
						case MAP_OPEN_CNF:
							op_pk_nfd_get(pkptr, "appContext", &appContext);
							op_pk_nfd_get(pkptr, "result", &result);
							break;
						default:
							break;
					}
				}
					
				}
				FSM_PROFILE_SECTION_OUT ("sgsn_map_user_process_model [idle exit execs]", state0_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("sgsn_map_user_process_model [idle trans conditions]", state0_trans_conds)
			FSM_INIT_COND (MAP_OPEN_CNF_RCVD)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("sgsn_map_user_process_model [idle trans conditions]", state0_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "MAP_OPEN_CNF_RCVD", "", "idle", "open")
				FSM_CASE_TRANSIT (1, 0, state0_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (open) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "open", "sgsn_map_user_process_model [open enter execs]")
				FSM_PROFILE_SECTION_IN ("sgsn_map_user_process_model [open enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("sgsn_map_user_process_model [open enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,sgsn_map_user_process_model)


			/** state (open) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "open", "sgsn_map_user_process_model [open exit execs]")
				FSM_PROFILE_SECTION_IN ("sgsn_map_user_process_model [open exit execs]", state1_exit_exec)
				{
				finished = 0;
				Packet * map_insert_subscriber_data_rsp_pkptr;
				Packet * map_insert_subscriber_data_ind_pkptr;
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
					pkptr = op_pk_get(op_intrpt_strm());
					op_pk_nfd_get(pkptr, "messageType", &messageType);
					switch (messageType) {
						case MAP_INSERT_SUBSCRIBER_DATA_IND:
							op_pk_send(pkptr, MAP_OUT_STRM_TO_SGSN);
							map_insert_subscriber_data_rsp_pkptr = op_pk_create_fmt ("MAP_INSERT_SUBSCRIBER_DATA_res"); 
							op_pk_send(map_insert_subscriber_data_rsp_pkptr, MAP_DSM_OUT_STRM_TO_HLR);
							break;
						case MAP_CLOSE_IND:
							finished = 1;
							break;
						case ATTACH_REQUEST:
							op_pk_nfd_get(pkptr, "imsi", &imsi);
							map_insert_subscriber_data_ind_pkptr = op_pk_create_fmt ("MAP_INSERT_SUBSCRIBER_DATA_ind");
							op_pk_nfd_set(map_insert_subscriber_data_ind_pkptr, "result", MAP_OPEN);
							op_pk_nfd_set(map_insert_subscriber_data_ind_pkptr, "imsi", imsi);
							op_pk_send(map_insert_subscriber_data_ind_pkptr, MAP_OUT_STRM_TO_SGSN);
							break;
						default:
							break;
					}
				}
				}
				FSM_PROFILE_SECTION_OUT ("sgsn_map_user_process_model [open exit execs]", state1_exit_exec)


			/** state (open) transition processing **/
			FSM_PROFILE_SECTION_IN ("sgsn_map_user_process_model [open trans conditions]", state1_trans_conds)
			FSM_INIT_COND (FINISHED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("open")
			FSM_PROFILE_SECTION_OUT ("sgsn_map_user_process_model [open trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 0, state0_enter_exec, ;, "FINISHED", "", "open", "idle")
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;, "default", "", "open", "open")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,sgsn_map_user_process_model)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
sgsn_map_user_process_model_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (sgsn_map_user_process_model_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (sgsn_map_user_process_model)",
			sizeof (sgsn_map_user_process_model_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((sgsn_map_user_process_model_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
sgsn_map_user_process_model_diag (void)
	{
	/* No Diagnostic Block */
	}




void
sgsn_map_user_process_model_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (sgsn_map_user_process_model_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in sgsn_map_user_process_model_svar function. */
#undef context



void
sgsn_map_user_process_model_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	sgsn_map_user_process_model_state		*prs_ptr;

	FIN (sgsn_map_user_process_model_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (sgsn_map_user_process_model_state *)gen_ptr;

	if (strcmp ("context" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->context);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

